Package com.io7m.cardant.protocol.inventory.cb

# Interface ProtocolCAIv1Type

All Superinterfaces:
  `com.io7m.cedarbridge.runtime.api.CBProtocolMessageType`, `com.io7m.cedarbridge.runtime.api.CBSerializableType`, `ProtocolCAIType`

All Known Implementing Classes:
  `CAI1CommandAuditSearchBegin`, `CAI1CommandAuditSearchNext`, `CAI1CommandAuditSearchPrevious`, `CAI1CommandFileGet`, `CAI1CommandFilePut`, `CAI1CommandFileRemove`, `CAI1CommandFileSearchBegin`, `CAI1CommandFileSearchNext`, `CAI1CommandFileSearchPrevious`, `CAI1CommandItemAttachmentAdd`, `CAI1CommandItemAttachmentRemove`, `CAI1CommandItemCreate`, `CAI1CommandItemGet`, `CAI1CommandItemLocationsList`, `CAI1CommandItemMetadataPut`, `CAI1CommandItemMetadataRemove`, `CAI1CommandItemReposit`, `CAI1CommandItemSearchBegin`, `CAI1CommandItemSearchNext`, `CAI1CommandItemSearchPrevious`, `CAI1CommandItemSetName`, `CAI1CommandItemsRemove`, `CAI1CommandItemTypesAssign`, `CAI1CommandItemTypesRevoke`, `CAI1CommandLocationAttachmentAdd`, `CAI1CommandLocationAttachmentRemove`, `CAI1CommandLocationGet`, `CAI1CommandLocationList`, `CAI1CommandLocationMetadataPut`, `CAI1CommandLocationMetadataRemove`, `CAI1CommandLocationPut`, `CAI1CommandLocationTypesAssign`, `CAI1CommandLocationTypesRevoke`, `CAI1CommandLogin`, `CAI1CommandRolesAssign`, `CAI1CommandRolesGet`, `CAI1CommandRolesRevoke`, `CAI1CommandTypePackageGetText`, `CAI1CommandTypePackageInstall`, `CAI1CommandTypePackageSearchBegin`, `CAI1CommandTypePackageSearchNext`, `CAI1CommandTypePackageSearchPrevious`, `CAI1CommandTypePackageUninstall`, `CAI1CommandTypePackageUpgrade`, `CAI1CommandTypeRecordGet`, `CAI1CommandTypeRecordSearchBegin`, `CAI1CommandTypeRecordSearchNext`, `CAI1CommandTypeRecordSearchPrevious`, `CAI1CommandTypeScalarGet`, `CAI1CommandTypeScalarSearchBegin`, `CAI1CommandTypeScalarSearchNext`, `CAI1CommandTypeScalarSearchPrevious`, `CAI1EventUpdated`, `CAI1ResponseAuditSearch`, `CAI1ResponseError`, `CAI1ResponseFileGet`, `CAI1ResponseFilePut`, `CAI1ResponseFileRemove`, `CAI1ResponseFileSearch`, `CAI1ResponseItemAttachmentAdd`, `CAI1ResponseItemAttachmentRemove`, `CAI1ResponseItemCreate`, `CAI1ResponseItemGet`, `CAI1ResponseItemLocationsList`, `CAI1ResponseItemMetadataPut`, `CAI1ResponseItemMetadataRemove`, `CAI1ResponseItemReposit`, `CAI1ResponseItemSearch`, `CAI1ResponseItemSetName`, `CAI1ResponseItemsRemove`, `CAI1ResponseItemTypesAssign`, `CAI1ResponseItemTypesRevoke`, `CAI1ResponseLocationAttachmentAdd`, `CAI1ResponseLocationAttachmentRemove`, `CAI1ResponseLocationGet`, `CAI1ResponseLocationList`, `CAI1ResponseLocationMetadataPut`, `CAI1ResponseLocationMetadataRemove`, `CAI1ResponseLocationPut`, `CAI1ResponseLocationTypesAssign`, `CAI1ResponseLocationTypesRevoke`, `CAI1ResponseLogin`, `CAI1ResponseRolesAssign`, `CAI1ResponseRolesGet`, `CAI1ResponseRolesRevoke`, `CAI1ResponseTypePackageGetText`, `CAI1ResponseTypePackageInstall`, `CAI1ResponseTypePackageSearch`, `CAI1ResponseTypePackageUninstall`, `CAI1ResponseTypePackageUpgrade`, `CAI1ResponseTypeRecordGet`, `CAI1ResponseTypeRecordSearch`, `CAI1ResponseTypeScalarGet`, `CAI1ResponseTypeScalarSearch`

public sealed interface ProtocolCAIv1Type extends ProtocolCAIType permits CAI1CommandAuditSearchBegin, CAI1CommandAuditSearchNext, CAI1CommandAuditSearchPrevious, CAI1CommandFileGet, CAI1CommandFilePut, CAI1CommandFileRemove, CAI1CommandFileSearchBegin, CAI1CommandFileSearchNext, CAI1CommandFileSearchPrevious, CAI1CommandItemAttachmentAdd, CAI1CommandItemAttachmentRemove, CAI1CommandItemCreate, CAI1CommandItemGet, CAI1CommandItemLocationsList, CAI1CommandItemMetadataPut, CAI1CommandItemMetadataRemove, CAI1CommandItemReposit, CAI1CommandItemSearchBegin, CAI1CommandItemSearchNext, CAI1CommandItemSearchPrevious, CAI1CommandItemSetName, CAI1CommandItemTypesAssign, CAI1CommandItemTypesRevoke, CAI1CommandItemsRemove, CAI1CommandLocationAttachmentAdd, CAI1CommandLocationAttachmentRemove, CAI1CommandLocationGet, CAI1CommandLocationList, CAI1CommandLocationMetadataPut, CAI1CommandLocationMetadataRemove, CAI1CommandLocationPut, CAI1CommandLocationTypesAssign, CAI1CommandLocationTypesRevoke, CAI1CommandLogin, CAI1CommandRolesAssign, CAI1CommandRolesGet, CAI1CommandRolesRevoke, CAI1CommandTypePackageGetText, CAI1CommandTypePackageInstall, CAI1CommandTypePackageSearchBegin, CAI1CommandTypePackageSearchNext, CAI1CommandTypePackageSearchPrevious, CAI1CommandTypePackageUninstall, CAI1CommandTypePackageUpgrade, CAI1CommandTypeRecordGet, CAI1CommandTypeRecordSearchBegin, CAI1CommandTypeRecordSearchNext, CAI1CommandTypeRecordSearchPrevious, CAI1CommandTypeScalarGet, CAI1CommandTypeScalarSearchBegin, CAI1CommandTypeScalarSearchNext, CAI1CommandTypeScalarSearchPrevious, CAI1EventUpdated, CAI1ResponseAuditSearch, CAI1ResponseError, CAI1ResponseFileGet, CAI1ResponseFilePut, CAI1ResponseFileRemove, CAI1ResponseFileSearch, CAI1ResponseItemAttachmentAdd, CAI1ResponseItemAttachmentRemove, CAI1ResponseItemCreate, CAI1ResponseItemGet, CAI1ResponseItemLocationsList, CAI1ResponseItemMetadataPut, CAI1ResponseItemMetadataRemove, CAI1ResponseItemReposit, CAI1ResponseItemSearch, CAI1ResponseItemSetName, CAI1ResponseItemTypesAssign, CAI1ResponseItemTypesRevoke, CAI1ResponseItemsRemove, CAI1ResponseLocationAttachmentAdd, CAI1ResponseLocationAttachmentRemove, CAI1ResponseLocationGet, CAI1ResponseLocationList, CAI1ResponseLocationMetadataPut, CAI1ResponseLocationMetadataRemove, CAI1ResponseLocationPut, CAI1ResponseLocationTypesAssign, CAI1ResponseLocationTypesRevoke, CAI1ResponseLogin, CAI1ResponseRolesAssign, CAI1ResponseRolesGet, CAI1ResponseRolesRevoke, CAI1ResponseTypePackageGetText, CAI1ResponseTypePackageInstall, CAI1ResponseTypePackageSearch, CAI1ResponseTypePackageUninstall, CAI1ResponseTypePackageUpgrade, CAI1ResponseTypeRecordGet, CAI1ResponseTypeRecordSearch, CAI1ResponseTypeScalarGet, CAI1ResponseTypeScalarSearch
Protocol `com.io7m.cardant.protocol.inventory.cb.CAI`, version `1`.

- ## Method Summary

  Static Methods
  Modifier and Type
  Method
  Description
  `static ProtocolCAIv1Type`
  `deserialize(com.io7m.cedarbridge.runtime.api.CBSerializationContextType $context)`
  Deserialize a value of type ProtocolCAIv1Type.
  `static void`
  `serialize(com.io7m.cedarbridge.runtime.api.CBSerializationContextType $context, ProtocolCAIv1Type $x)`
  Serialize a value of type ProtocolCAIv1Type.

- ## Method Details

  - ### serialize

    static void serialize(com.io7m.cedarbridge.runtime.api.CBSerializationContextType $context, ProtocolCAIv1Type $x) throws IOException
    Serialize a value of type ProtocolCAIv1Type.
    Parameters:
      `$context` - The serialization context.
      `$x` - The value to be serialized.
    Throws:
      `IOException`

  - ### deserialize

    static ProtocolCAIv1Type deserialize(com.io7m.cedarbridge.runtime.api.CBSerializationContextType $context) throws IOException
    Deserialize a value of type ProtocolCAIv1Type.
    Parameters:
      `$context` - The serialization context.
    Returns:
      A value of type ProtocolCAIv1Type.
    Throws:
      `IOException`